#include <htc.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

#include "delay.h"
#include "sw_i2c.h"


//-----------------------------------------------------------------
//Routines for DS1307
//-----------------------------------------------------------------


void write_ds1307(unsigned char address, unsigned char data)
{	di();
   short int status;
   SWStartI2C();
   SWPutcI2C(0xd0);
   SWPutcI2C(address);
   SWPutcI2C(data);
   SWStopI2C();
   SWRestartI2C();
   status=SWPutcI2C(0xd0);
   while(status==1)
   {
      SWStartI2C();
      status=SWPutcI2C(0xd0);
   }
   DelayMs(10);
   ei();
}
//==========================
// read data one byte from DS1307
//==========================
unsigned char read_ds1307(unsigned char address)
{
	di();
   unsigned char data;
   SWStartI2C();
   SWPutcI2C(0xd0);
   SWPutcI2C(address);
   SWRestartI2C();
   SWPutcI2C(0xd1);
   data = SWGetsI2C( 0, 0 );
   SWStopI2C();
   ei();
   return(data);
}




void main(void){
	
	unsigned char sec,min,hour,day,date,month,year;
	   
	BRGH = 1 ;
	SYNC = 0;
	SPBRG = 129;//9600
	TXSTA = 0x20;
	RCSTA = 0x09;
	TRISC6 = 0;
	TRISC7 = 1;
	
	sec = read_ds1307(0);
  	write_ds1307(0,sec & 0x7F); // enable oscillator(bit 7 =0)
	
	//Set Time
		write_ds1307(0,0x80); //Reset second to 0 sec. and stop Oscillator
		write_ds1307(1,0x10); //write min 27
		write_ds1307(2,0x01); //write hour 14
		write_ds1307(3,0x02); //write day of week 2:Monday
		write_ds1307(4,0x05); // write date 17
		write_ds1307(5,0x01); // write month 6 June
		write_ds1307(6,0x09); // write year 8 --> 2008
		write_ds1307(7,0x10); //SQWE output at 1 Hz
		write_ds1307(0,0x00); //Reset second to 0 sec. and start Oscillator
		
	while(1)
	{

			
	 sec=read_ds1307(0);   // read second
     min=read_ds1307(1);   // read minute
     hour=read_ds1307(2);  // read hour
     day=read_ds1307(3);   // read day
     date=read_ds1307(4);  // read date
     month=read_ds1307(5); // read month
     year=read_ds1307(6);  // read year
     putch(0x0c);
   
   	 printf("Time : %02d:%02d:%02d\r\n",hour,min,sec);
     printf("Day  : %02d\r\n",date);
     printf("Date : %02d/%02d/20%02d\r\n",day,month,year); 
     DelayMs(500);	
	}	
}	

