#include <htc.h>
#ifndef __SWI2C16_H
#define __SWI2C16_H

/* PIC18 software I2C interface header */

/*****   COMMON FUNCTION PROTOTYPES   *****/

void SWStopI2C ( void );                // Generate bus stop condition
void SWStartI2C ( void );               // Generate bus start condition
void SWRestartI2C ( void );             // Generate bus restart condition
void SWStopI2C ( void );                // Generate bus stop condition

// USER NEEDS TO DEFINE DATA AND CLOCK  RESISTORS ARE REQUIRED ON 
// DATA AND CLOCK  

#if defined(__18F1220) || defined(__18F1320) ||\
	defined(__18F1230) || defined(__18F1330)
#define  DATA_LOW   TRISB4 = 0; // define macro for data pin output
#define  DATA_HI    TRISB4 = 1; // define macro for data pin input
#define  DATA_LAT   LATB4        // define macro for data pin latch
#define  DATA_PIN   PORTBbits.RB4         // define macro for data pin

#define  CLOCK_LOW  TRISB3 = 0; // define macro for clock pin output
#define  CLOCK_HI   TRISB3 = 1; // define macro for clock pin input
#define  SCLK_LAT   LATB3        // define macro for clock pin latch
#define  SCLK_PIN   PORTBbits.RB3         // define macro for clock pin

#elif defined(__18F2455) || defined(__18F2550) || \
      defined(__18F4455) || defined(__18F4550) || \
	  defined(__18F2450) || defined(__18F2458) ||\
	  defined(__18F2553) || defined(__18F4450) ||\
	  defined(__18F4458) || defined(__18F4553) 

#define  DATA_LOW   TRISB0 = 0; // define macro for data pin output
#define  DATA_HI    TRISB0 = 1; // define macro for data pin input
#define  DATA_LAT   LATB0        // define macro for data pin latch
#define  DATA_PIN   PORTBbits.RB0         // define macro for data pin

#define  CLOCK_LOW  TRISB1 = 0; // define macro for clock pin output
#define  CLOCK_HI   TRISB1 = 1; // define macro for clock pin input
#define  SCLK_LAT   LATB1        // define macro for clock pin latch
#define  SCLK_PIN   PORTBbits.RB1         // define macro for clock pin

#elif defined(__18F24J50) || defined(__18F25J50) || \
	  defined(__18LF24J50) || defined(__18LF25J50) || \
      defined(__18F26J50) || defined(__18F44J50) || \
      defined(__18LF26J50) || defined(__18LF44J50) || \
	  defined(__18F45J50) || defined(__18F46J50) || \
	  defined(__18LF45J50) || defined(__18LF46J50)
	  
#define  DATA_LOW   TRISB5 = 0; // define macro for data pin output
#define  DATA_HI    TRISB5 = 1; // define macro for data pin input
#define  DATA_LAT   LATB5        // define macro for data pin latch
#define  DATA_PIN   PORTBbits.RB5         // define macro for data pin

#define  CLOCK_LOW  TRISB4 = 0; // define macro for clock pin output
#define  CLOCK_HI   TRISB4 = 1; // define macro for clock pin input
#define  SCLK_LAT   LATB4        // define macro for clock pin latch
#define  SCLK_PIN   PORTBbits.RB4         // define macro for clock pin	  

#else

#define  DATA_LOW   TRISC4 = 0; // define macro for data pin output
#define  DATA_HI    TRISC4 = 1; // define macro for data pin input
#define  DATA_LAT   LATC4        // define macro for data pin latch
#define  DATA_PIN   PORTCbits.RC4         // define macro for data pin

#define  CLOCK_LOW  TRISC3 = 0; // define macro for clock pin output
#define  CLOCK_HI   TRISC3 = 1; // define macro for clock pin input
#define  SCLK_LAT   LATC3        // define macro for clock pin latch
#define  SCLK_PIN   PORTCbits.RC3         // define macro for clock pin
#endif

/*****   FUNCTION PROTOTYPES FOR PIC18CXXX   *****/
signed char SWAckI2C( void );             // Read bus ACK condition
signed char Clock_test( void );
unsigned int SWReadI2C( void );          // Read in single byte 
signed char SWWriteI2C(  unsigned char data_out ); // Write out single byte
signed char SWGetsI2C(  unsigned char *rdptr,  unsigned char length );   // Read in string from I2C module
signed char SWPutsI2C(  unsigned char *wrptr );    // Write string to I2C module

#define  SWPutcI2C    SWWriteI2C
#define  SWGetcI2C    SWReadI2C
#define  SWNotAckI2C  SWAckI2C
#endif
